/*

This function Initializes the NFC and the Interrupts. 
Also, this function initialzes the  "WriteData" buffer 
which is written to Nand Flash

*/



#include "Extern_Declaration.h"

/**********************************************************************/

void Init(void)
{
	
	
	// PLL initialization
	
	*pPLL_CTL = MSELECT;
	ssync();
	idle();
	*pPLL_DIV = CSELECT | SSELECT;
	ssync();
	
	
	//initialize the buffer to write into NAND flash
	

	for(i=0; i<Flash_Page_Size; i++)
	{
		WriteData[i] = i+1;
	}
	
	//Port config to enable NFC
	
	*pPORTH_FER = PH0 | PH1 | PH2 |PH3 | PH4 | PH5 | PH6 | PH7 | PH10 | PH11 | PH12 | PH13 | PH14 | PH15;
	*pPORTH_MUX = 0;
	
	// Set up NFC
	
	*pNFC_CTL = ((WR_DLY & Write_Strobe_Delay) | (RD_DLY & (Read_Strobe_Delay << 4)));
	
	if(NFC_PAGE_SIZE == 512)
	{
		*pNFC_CTL |= PG_SIZE;
	}
		
	
	*pNFC_RST = ECC_RST;		//clear ECC registers and counters
	
	// Unmask the IRQ bits. 
	*pNFC_IRQMASK = nMASK_WRDONE | nMASK_BUSYIRQ | nMASK_WBOVF | MASK_WBEDGE | MASK_RDRDY;

	//enable DMA interrupt for NFC
	
	register_handler(ik_ivg11, NFC_ISR);		
	*pSIC_IMASK0 |= IRQ_DMA2;
		

	//enable NFC Error interrupt
	
	register_handler(ik_ivg7, NFC_IRQSTAT_ISR);		
	*pSIC_IMASK1 |= IRQ_NAND_ERR;
	ssync();
	

	printf("Initialization Completed\n");
		
}

/**********************************************************************/

